<?php

namespace Teknisa\CTB\Controllers;

use Zeedhi\Framework\DTO;
use Teknisa\CTB\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO\Response\Error;

class ContopectblEmpresa extends TeknisaCrud{
    protected $dataSourceName = 'contopectbl_empresa';
    protected $dataSourceNameToSave = 'contopectbl';
    protected $nrorg;
    protected $contopectblEmpresaService;

    public function __construct($crudService, $parameterBag,  $environment, $contopectblEmpresaService) {
        parent::__construct($crudService, $parameterBag);
        $this->nrorg = $environment->getNrOrgTrab();
        $this->contopectblEmpresaService = $contopectblEmpresaService;
    }

    public function save(DTO\Request $request, DTO\Response $response) {
        $dataSet = $request->getDataSet();
        $rows = $dataSet->getRows();
        $method = $request->getMethod();
        $routePath = $request->getRoutePath();
        $userId = $request->getUserId();
        try {
            $this->contopectblEmpresaService->checaRow($rows[0]);
            $this->contopectblEmpresaService->ferificDataSuperior($this->nrorg, $rows[0]["CDEMPRESA"], $rows[0]["DTFINACONT"]);
            $newRequest = $this->contopectblEmpresaService->setIdsaldempr($rows[0], 'contopectbl', $method, $routePath, $userId);
            parent::save($newRequest, $response);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage() , 500));
        }
    }

    public function deletar(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();

        try {
            $this->contopectblEmpresaService->checaLancaEmp($this->nrorg, $row['CDEMPRESA']);
            $this->dataSourceName = 'contopectbl';
            parent::delete($request, $response);
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage() , 500));
        }
    }
}